package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.OcrCutConfig;
import com.docus.server.entity.segmentation.OcrSpecialRule;
import com.docus.server.infrastructure.dao.IOcrCutConfigDao;
import com.docus.server.infrastructure.mapper.OcrCutConfigMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * ocr图片剪切配置 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-29
 */
@Repository
public class OcrCutConfigDaoImpl extends BaseDaoImpl<OcrCutConfigMapper, OcrCutConfig> implements IOcrCutConfigDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public OcrCutConfig findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param ocrCutConfig 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(OcrCutConfig ocrCutConfig) {
        return super.save(ocrCutConfig);
    }

    /**
     * 编辑
     *
     * @param ocrCutConfig 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(OcrCutConfig ocrCutConfig) {
        return super.updateById(ocrCutConfig);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<OcrCutConfig> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<OcrCutConfig> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(OcrCutConfig::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(OcrCutConfig::getCreateTime, endTime);
        }

        Object version = searchDTO.getParams("version");
        query.eq(OcrCutConfig::getVersion,version);


        query.orderByDesc(OcrCutConfig::getCreateTime);
        List<OcrCutConfig> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<OcrCutConfig> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(OcrCutConfig::getId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(OcrCutConfig::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
